from malaria.interventions.health_seeking import add_health_seeking
from malaria.interventions.irs import add_reactive_node_IRS
from malaria.study_sites.site_setup_functions import add_treatment_fn, add_mosquito_release_fn

from dtk.interventions.mosquito_release import add_mosquito_release
from dtk.utils.core.DTKConfigBuilder import DTKConfigBuilder


from dtk.utils.Campaign.CampaignClass import SimpleBednet, CalendarEventCoordinator, \
    CalendarEventCoordinator_Target_Demographic_Enum


def test():
    s = CalendarEventCoordinator(Target_Demographic=CalendarEventCoordinator_Target_Demographic_Enum.AllDepartingTravellers, test='hello')
    print(s)

    print(s.__dict__)

    print(s.Target_Demographic, type(s.Target_Demographic))

    print(s.to_json(False))


def test_fn():
    cb = DTKConfigBuilder.from_defaults('MALARIA_SIM')
    add_treatment_fn(cb)
    print(cb)


def test_health_seeking():
    cb = DTKConfigBuilder.from_defaults("MALARIA_SIM")
    add_health_seeking(config_builder=cb, start_day=7)
    print(cb)


def test_add_reactive_node_IRS():
    cb = DTKConfigBuilder.from_defaults("MALARIA_SIM")
    add_reactive_node_IRS(config_builder=cb, start=7, nodeIDs={"class": "NodeSetAll"})
    print(cb)


def test_add_mosquito_release():
    cb = DTKConfigBuilder.from_defaults("MALARIA_SIM")
    add_mosquito_release(cb, start_day=7)
    print(cb)


def test_add_mosquito_release_fn():
    cb = DTKConfigBuilder.from_defaults("MALARIA_SIM")
    A = add_mosquito_release_fn(start_day=7,
                                vector_species = '1', number_vectors=2, repetitions=-1
                                )

    A(cb)
    print(cb)



if __name__ == "__main__":
    # test_fn()
    # exit()

    # test_health_seeking()
    # exit()

    test_add_reactive_node_IRS()
    exit()

    # test_add_mosquito_release()
    # exit()

    test_add_mosquito_release_fn()
    exit()