from simtools.SetupParser import SetupParser
from simtools.AssetManager.FileList import FileList

from simtools.Services.Utility.DockerAnalyzeManager import DockerAnalyzeManager
from simtools.Services.Samples.example5.files.DockerTimeSeriesAnalyzer import DockerTimeseriesAnalyzer
from simtools.Services.Samples.example6.files.DockerVectorSpeciesAnalyzer import DockerVectorSpeciesAnalyzer
from dtk.utils.analyzers.plot import plot_grouped_lines
from dtk.utils.analyzers import sample_selection
from dtk.utils.analyzers.group import group_by_name

from simtools.Services.Utility.SSMTManagers.WorkItemManager import WorkItemManager

wi_name = "Demo Dockder WorkItem 6-1"
# command = "dtk analyze -id dea2b957-5ba5-e811-80c9-f0921c167864 -a Docker_DockerVectorSpeciesAnalyzer.py"
files = ['simtools.ini', 'DockerMultipleAnalyzer.py']
user_files = FileList(root='files', files_in_root=files)

exp_list = ['dea2b957-5ba5-e811-80c9-f0921c167864']
analyzers = [
    DockerTimeseriesAnalyzer(select_function=sample_selection(), group_function=group_by_name('_site_'),
                             plot_function=plot_grouped_lines, saveOutput=True),
    DockerVectorSpeciesAnalyzer(select_function=sample_selection(), group_function=group_by_name('_site_'))
]

if __name__ == "__main__":
    SetupParser.default_block = 'HPC'
    SetupParser.init()

    wim = WorkItemManager(item_name=wi_name, command=None, user_files=user_files)
    dam = DockerAnalyzeManager(exp_list, analyzers, wim)
    dam.analyze(True)



