from simtools.AnalyzeManager import AnalyzeManager
from simtools.SetupParser import SetupParser
from simtools.AssetManager.FileList import FileList
from simtools.AssetManager.AssetFile import AssetFile

from dtk.utils.analyzers.plot import plot_grouped_lines
from dtk.utils.analyzers import sample_selection
from dtk.utils.analyzers.group import group_by_name

from .DockerTimeSeriesAnalyzer import DockerTimeseriesAnalyzer
from .WorkItemManager import WorkItemManager


exp_list = ['dea2b957-5ba5-e811-80c9-f0921c167864']
analyzers = [
    DockerTimeseriesAnalyzer(select_function=sample_selection(), group_function=group_by_name('_site_'),
                             plot_function=plot_grouped_lines, saveOutput=True)
]

if __name__ == "__main__":
    SetupParser.default_block = 'HPC'
    SetupParser.init()

    a = AnalyzeManager(exp_list=exp_list, analyzers=analyzers)
    a.analyze()




