from simtools.SetupParser import SetupParser
from simtools.AssetManager.FileList import FileList
from simtools.AssetManager.AssetFile import AssetFile

from dtk.utils.analyzers.plot import plot_grouped_lines
from dtk.utils.analyzers import sample_selection
from dtk.utils.analyzers.group import group_by_name

from simtools.Services.Samples.more.DockerTimeSeriesAnalyzer import DockerTimeseriesAnalyzer
from simtools.Services.Utility.SSMTManagers.WorkItemManager import WorkItemManager


wi_name = "Demo Dockder WorkItem 6-3"
command = "python example_ssmt.py"
files = ['simtools.ini', 'DockerTimeseriesAnalyzer.py', 'WorkItemManager.py', 'WorkOrder.py']
user_files = FileList(root='files', files_in_root=files)

# add entry file
user_files.add_asset_file(AssetFile(file_name='example_ssmt.py', absolute_path='C:\Projects\dtk-tools-zdu\simtools\Services\Samples\example_ssmt.py'))

exp_list = ['dea2b957-5ba5-e811-80c9-f0921c167864']
analyzers = [
    DockerTimeseriesAnalyzer(select_function=sample_selection(), group_function=group_by_name('_site_'),
                             plot_function=plot_grouped_lines, saveOutput=True)
]

if __name__ == "__main__":
    SetupParser.default_block = 'HPC'
    SetupParser.init()

    wim = WorkItemManager(item_name=wi_name, command=command, user_files=user_files)
    wim.execute(True)



